# Record Class CSCertificate

java.lang.Object
java.lang.Record
com.io7m.certusine.api.CSCertificate

Record Components:
  `name` - The name used to refer to certificate
  `keyPair` - The keypair used for the certificate
  `hosts` - The list of hosts in the certificate

public record CSCertificate(CSCertificateName name, KeyPair keyPair, List<String> hosts) extends Record
A request for a certificate within a domain. A certificate is used to assign some degree of trust as to the identity of the holder of the keypair.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `CSCertificate(CSCertificateName name, KeyPair keyPair, List<String> hosts)`
  A request for a certificate within a domain.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `final boolean`
  `equals(Object o)`
  Indicates whether some other object is "equal to" this one.
  `List<String>`
  `fullyQualifiedHostNames(CSDomain domain)`
  `final int`
  `hashCode()`
  Returns a hash code value for this object.
  `List<String>`
  `hosts()`
  Returns the value of the `hosts` record component.
  `KeyPair`
  `keyPair()`
  Returns the value of the `keyPair` record component.
  `CSCertificateName`
  `name()`
  Returns the value of the `name` record component.
  `final String`
  `toString()`
  Returns a string representation of this record class.

  ### Methods inherited from class Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### CSCertificate

    public CSCertificate(CSCertificateName name, KeyPair keyPair, List<String> hosts)
    A request for a certificate within a domain. A certificate is used to assign some degree of trust as to the identity of the holder of the keypair.
    Parameters:
      `name` - The name used to refer to certificate
      `keyPair` - The keypair used for the certificate
      `hosts` - The list of hosts in the certificate

- ## Method Details

  - ### fullyQualifiedHostNames

    public List<String> fullyQualifiedHostNames(CSDomain domain)
    Parameters:
      `domain` - The domain
    Returns:
      The fully-qualified hostnames for this certificate

  - ### toString

    public final String toString()
    Returns a string representation of this record class. The representation contains the name of the class, followed by the name and value of each of the record components.
    Specified by:
      `toString` in class `Record`
    Returns:
      a string representation of this object

  - ### hashCode

    public final int hashCode()
    Returns a hash code value for this object. The value is derived from the hash code of each of the record components.
    Specified by:
      `hashCode` in class `Record`
    Returns:
      a hash code value for this object

  - ### equals

    public final boolean equals(Object o)
    Indicates whether some other object is "equal to" this one. The objects are equal if the other object is of the same class and if all the record components are equal. All components in this record class are compared with `Objects::equals(Object,Object)`.
    Specified by:
      `equals` in class `Record`
    Parameters:
      `o` - the object with which to compare
    Returns:
      `true` if this object is the same as the `o` argument; `false` otherwise.

  - ### name

    public CSCertificateName name()
    Returns the value of the `name` record component.
    Returns:
      the value of the `name` record component

  - ### keyPair

    public KeyPair keyPair()
    Returns the value of the `keyPair` record component.
    Returns:
      the value of the `keyPair` record component

  - ### hosts

    public List<String> hosts()
    Returns the value of the `hosts` record component.
    Returns:
      the value of the `hosts` record component